ViewVC Help
View File | Revision Log | Show Annotations | Download File
/cvs/App-Staticperl/staticperl.sh
(Generate patch)

Comparing App-Staticperl/staticperl.sh (file contents):
Revision 1.4 by root, Tue Dec 7 09:27:54 2010 UTC vs.
Revision 1.23 by root, Sat Dec 18 13:58:12 2010 UTC

1#!/bin/sh 1#!/bin/sh
2 2
3############################################################################# 3#############################################################################
4# configuration to fill in 4# configuration to fill in
5 5
6PERLVER=5.12.2 # 5.8.9 is also a good choice
7STATICPERL=~/.staticperl 6STATICPERL=~/.staticperl
8CPAN=http://mirror.netcologne.de/cpan/ # which mirror to use 7CPAN=http://mirror.netcologne.de/cpan # which mirror to use
9EMAIL="read the documentation <rtfm@example.org>" 8EMAIL="read the documentation <rtfm@example.org>"
10 9
11MKBUNDLE="$STATICPERL/mkbundle"
12
13# perl build variables 10# perl build variables
14PREFIX="$STATICPERL/perl" # where the perl gets installed 11MAKE=make
12PERL_VERSION=5.12.2 # 5.8.9 is also a good choice
13PERL_CC=cc
15PERL_CONFIGURE="" # additional Configure arguments 14PERL_CONFIGURE="" # additional Configure arguments
16PERL_CPPFLAGS="-DPERL_DISABLE_PMC -DPERL_ARENA_SIZE=65536 -D_GNU_SOURCE -DNDEBUG -USITELIB_EXP -USITEARCHEXP -UARCHLIB_EXP" 15PERL_CCFLAGS="-DPERL_DISABLE_PMC -DPERL_ARENA_SIZE=65536 -D_GNU_SOURCE -DNDEBUG"
17PERL_OPTIMIZE="-Os -ffunction-sections -fdata-sections -finline-limit=8 -ffast-math" 16PERL_OPTIMIZE="-Os -ffunction-sections -fdata-sections -finline-limit=8 -ffast-math"
18 17
19ARCH="$(uname -m)" 18ARCH="$(uname -m)"
20 19
21case "$ARCH" in 20case "$ARCH" in
29 ;; 28 ;;
30esac 29esac
31 30
32# -Wl,--gc-sections makes it impossible to check for undefined references 31# -Wl,--gc-sections makes it impossible to check for undefined references
33# for some reason so we need to patch away the "-no" after Configure and before make :/ 32# for some reason so we need to patch away the "-no" after Configure and before make :/
34# -z muldefs is to work around uclibc's pthread static linking bug 33# --allow-multiple-definition exists to work around uclibc's pthread static linking bug
35PERL_LDFLAGS="-Wl,--no-gc-sections -z muldefs" 34PERL_LDFLAGS="-Wl,--no-gc-sections -Wl,--allow-multiple-definition"
36PERL_LIBS="-lm -lcrypt" # perl loves to add lotsa crap itself 35PERL_LIBS="-lm -lcrypt" # perl loves to add lotsa crap itself
37 36
38# some configuration options for modules 37# some configuration options for modules
39export PERL_MM_USE_DEFAULT=1 38export PERL_MM_USE_DEFAULT=1
40#export CORO_INTERFACE=p # needed without nptl on x86, due to bugs in linuxthreads - very slow 39#export CORO_INTERFACE=p # needed without nptl on x86, due to bugs in linuxthreads - very slow
46 45
47# which extra modules you might want to install 46# which extra modules you might want to install
48EXTRA_MODULES="" 47EXTRA_MODULES=""
49 48
50# overridable functions 49# overridable functions
50preconfigure() { : ; }
51postconfigure() { : ; } 51postconfigure() { : ; }
52postbuild() { : ; } 52postbuild() { : ; }
53postinstall() { : ; } 53postinstall() { : ; }
54 54
55# now source user config, if any 55# now source user config, if any
56if [ "$STATICPERLRC" ]; then
57 . "$STATICPERLRC"
58else
56[ -r /etc/staticperlrc ] && . /etc/staticperlrc 59 [ -r /etc/staticperlrc ] && . /etc/staticperlrc
57[ -r ~/.staticperlrc ] && . ~/.staticperlrc 60 [ -r ~/.staticperlrc ] && . ~/.staticperlrc
58[ -r "$STATICPERL/rc" ] && . "$STATICPERL/rc" 61 [ -r "$STATICPERL/rc" ] && . "$STATICPERL/rc"
62fi
59 63
60############################################################################# 64#############################################################################
61# support 65# support
66
67MKBUNDLE="${MKBUNDLE:=$STATICPERL/mkbundle}"
68PERL_PREFIX="${PERL_PREFIX:=$STATICPERL/perl}" # where the perl gets installed
69
70unset PERL5OPT PERL5LIB PERLLIB PERL_UNICODE PERLIO_DEBUG
71export LC_ALL=C # just to be on the safe side
62 72
63# set version in a way that Makefile.PL can extract 73# set version in a way that Makefile.PL can extract
64VERSION=VERSION; eval \ 74VERSION=VERSION; eval \
65$VERSION=0.1 75$VERSION=0.912
66 76
67BZ2=bz2 77BZ2=bz2
68BZIP2=bzip2 78BZIP2=bzip2
69 79
70fatal() { 80fatal() {
103############################################################################# 113#############################################################################
104# clean 114# clean
105 115
106distclean() { 116distclean() {
107 verblock <<EOF 117 verblock <<EOF
108deleting everything installed by this script 118 deleting everything installed by this script (rm -rf $STATICPERL)
109EOF 119EOF
110 120
111 rm -rf "$STATICPERL" 121 rm -rf "$STATICPERL"
112} 122}
113 123
114############################################################################# 124#############################################################################
115# download/configure/compile/install perl 125# download/configure/compile/install perl
116 126
117clean() { 127clean() {
118 cd "$STATICPERL/src/perl-$PERLVER" 2>/dev/null || return 128 rm -rf "$STATICPERL/src/perl-$PERL_VERSION"
129}
119 130
120 rm -f staticstamp.configure 131realclean() {
121 make distclean >/dev/null 2>&1 132 rm -f "$PERL_PREFIX/staticstamp.postinstall"
133 rm -f "$PERL_PREFIX/staticstamp.install"
134 rm -f "$STATICPERL/src/perl-"*"/staticstamp.configure"
122} 135}
123 136
124fetch() { 137fetch() {
125 rcd "$STATICPERL" 138 rcd "$STATICPERL"
126 139
127 mkdir -p src 140 mkdir -p src
128 rcd src 141 rcd src
129 142
130 if ! [ -d "perl-$PERLVER" ]; then 143 if ! [ -d "perl-$PERL_VERSION" ]; then
131 if ! [ -e "perl-$PERLVER.tar.$BZ2" ]; then 144 if ! [ -e "perl-$PERL_VERSION.tar.$BZ2" ]; then
132 145
133 URL="$CPAN/src/5.0/perl-$PERLVER.tar.$BZ2" 146 URL="$CPAN/src/5.0/perl-$PERL_VERSION.tar.$BZ2"
134 147
135 verblock <<EOF 148 verblock <<EOF
136downloading perl 149downloading perl
137to manually download perl yourself, place 150to manually download perl yourself, place
138perl-$PERLVER.tar.$BZ2 in $STATICPERL 151perl-$PERL_VERSION.tar.$BZ2 in $STATICPERL
139trying $URL 152trying $URL
140EOF 153EOF
141 154
142 curl >perl-$PERLVER.tar.$BZ2~ "$URL" \ 155 rm -f perl-$PERL_VERSION.tar.$BZ2~ # just to be on the safe side
143 || wget -O perl-$PERLVER.tar.$BZ2~ "$URL" \ 156 wget -O perl-$PERL_VERSION.tar.$BZ2~ "$URL" \
157 || curl >perl-$PERL_VERSION.tar.$BZ2~ "$URL" \
144 || fatal "$URL: error during downloading" 158 || fatal "$URL: unable to download"
159 rm -f perl-$PERL_VERSION.tar.$BZ2
145 mv perl-$PERLVER.tar.$BZ2~ perl-$PERLVER.tar.$BZ2 160 mv perl-$PERL_VERSION.tar.$BZ2~ perl-$PERL_VERSION.tar.$BZ2
146 fi 161 fi
147 162
148 verblock <<EOF 163 verblock <<EOF
149unpacking perl 164unpacking perl
150EOF 165EOF
151 166
152 mkdir -p unpack 167 mkdir -p unpack
168 rm -rf unpack/perl-$PERL_VERSION
153 $BZIP2 -d <perl-$PERLVER.tar.bz2 | tar xpC unpack \ 169 $BZIP2 -d <perl-$PERL_VERSION.tar.bz2 | tar xfC - unpack \
154 || fatal "perl-$PERLVER.tar.bz2: error during unpacking" 170 || fatal "perl-$PERL_VERSION.tar.bz2: error during unpacking"
171 chmod -R u+w unpack/perl-$PERL_VERSION
155 mv unpack/perl-$PERLVER perl-$PERLVER 172 mv unpack/perl-$PERL_VERSION perl-$PERL_VERSION
156 rmdir -p unpack 173 rmdir -p unpack
157 fi 174 fi
158} 175}
159 176
160# similar to GNU-sed -i or perl -pi 177# similar to GNU-sed -i or perl -pi
161sedreplace() { 178sedreplace() {
162 sed -e "$1" <"$2" > "$2~" || fatal "error while running sed" 179 sed -e "$1" <"$2" > "$2~" || fatal "error while running sed"
180 rm -f "$2"
163 mv "$2~" "$2" 181 mv "$2~" "$2"
182}
183
184configure_failure() {
185 cat <<EOF
186
187
188***
189*** Configure failed - see above for the exact error message(s).
190***
191*** Most commonly, this is because the default PERL_CCFLAGS or PERL_OPTIMIZE
192*** flags are not supported by your compiler. Less often, this is because
193*** PERL_LIBS either contains a library not available on your system (such as
194*** -lcrypt), or because it lacks a required library (e.g. -lsocket or -lnsl).
195***
196*** You can provide your own flags by creating a ~/.staticperlrc file with
197*** variable assignments. For example (these are the actual values used):
198***
199
200PERL_CC="$PERL_CC"
201PERL_CCFLAGS="$PERL_CCFLAGS"
202PERL_OPTIMIZE="$PERL_OPTIMIZE"
203PERL_LDFLAGS="$PERL_LDFLAGS"
204PERL_LIBS="$PERL_LIBS"
205
206EOF
207 exit 1
164} 208}
165 209
166configure() { 210configure() {
167 fetch 211 fetch
168 212
169 rcd "$STATICPERL/src/perl-$PERLVER" 213 rcd "$STATICPERL/src/perl-$PERL_VERSION"
170 214
171 [ -e staticstamp.configure ] && return 215 [ -e staticstamp.configure ] && return
172 216
173 verblock <<EOF 217 verblock <<EOF
174configuring $STATICPERL/src/perl-$PERLVER 218configuring $STATICPERL/src/perl-$PERL_VERSION
175EOF 219EOF
176 220
177 clean
178
179 rm -f "$PREFIX/staticstamp.install" 221 rm -f "$PERL_PREFIX/staticstamp.install"
180 222
223 "$MAKE" distclean >/dev/null 2>&1
224
225 sedreplace '/^#define SITELIB/d' config_h.SH
226
181 # I hate them 227 # I hate them for this
182 grep -q -- -fstack-protector Configure && \ 228 grep -q -- -fstack-protector Configure && \
183 sedreplace 's/-fstack-protector/-fno-stack-protector/g' Configure 229 sedreplace 's/-fstack-protector/-fno-stack-protector/g' Configure
230
231 preconfigure
184 232
185# trace configure \ 233# trace configure \
186 sh Configure -Duselargefiles \ 234 sh Configure -Duselargefiles \
187 -Uuse64bitint \ 235 -Uuse64bitint \
188 -Dusemymalloc=n \ 236 -Dusemymalloc=n \
189 -Uusedl \ 237 -Uusedl \
190 -Uusethreads \ 238 -Uusethreads \
191 -Uuseithreads \ 239 -Uuseithreads \
192 -Uusemultiplicity \ 240 -Uusemultiplicity \
193 -Duseperlio \
194 -Uusesfio \ 241 -Uusesfio \
195 -Uuseshrplib \ 242 -Uuseshrplib \
196 -Dcppflags="$PERL_CPPFLAGS" \ 243 -A ccflags=" $PERL_CCFLAGS" \
197 -Dccflags="-g2 -fno-strict-aliasing" \ 244 -Dcc="$PERL_CC" \
198 -Doptimize="$PERL_OPTIMIZE" \ 245 -Doptimize="$PERL_OPTIMIZE" \
199 -Dldflags="$PERL_LDFLAGS" \ 246 -Dldflags="$PERL_LDFLAGS" \
200 -Dlibs="$PERL_LIBS" \ 247 -Dlibs="$PERL_LIBS" \
201 -Dprefix="$PREFIX" \ 248 -Dprefix="$PERL_PREFIX" \
202 -Dbin="$PREFIX/bin" \ 249 -Dbin="$PERL_PREFIX/bin" \
203 -Dprivlib="$PREFIX/lib" \ 250 -Dprivlib="$PERL_PREFIX/lib" \
204 -Darchlib="$PREFIX/lib" \ 251 -Darchlib="$PERL_PREFIX/lib" \
205 -Uusevendorprefix \ 252 -Uusevendorprefix \
206 -Dsitelib="$PREFIX/lib" \ 253 -Dsitelib="$PERL_PREFIX/lib" \
207 -Dsitearch="$PREFIX/lib" \ 254 -Dsitearch="$PERL_PREFIX/lib" \
208 -Usitelibexp \
209 -Uman1dir \ 255 -Uman1dir \
210 -Uman3dir \ 256 -Uman3dir \
211 -Usiteman1dir \ 257 -Usiteman1dir \
212 -Usiteman3dir \ 258 -Usiteman3dir \
213 -Dpager=/usr/bin/less \ 259 -Dpager=/usr/bin/less \
214 -Demail="$EMAIL" \ 260 -Demail="$EMAIL" \
215 -Dcf_email="$EMAIL" \ 261 -Dcf_email="$EMAIL" \
216 -Dcf_by="$EMAIL" \ 262 -Dcf_by="$EMAIL" \
217 $PERL_CONFIGURE \ 263 $PERL_CONFIGURE \
264 -Duseperlio \
218 -dE || fatal "Configure failed" 265 -dE || configure_failure
219 266
220 sedreplace ' 267 sedreplace '
221 s/-Wl,--no-gc-sections/-Wl,--gc-sections/g 268 s/-Wl,--no-gc-sections/-Wl,--gc-sections/g
222 s/ *-fno-stack-protector */ /g 269 s/ *-fno-stack-protector */ /g
223 ' config.sh 270 ' config.sh
230} 277}
231 278
232build() { 279build() {
233 configure 280 configure
234 281
235 rcd "$STATICPERL/src/perl-$PERLVER" 282 rcd "$STATICPERL/src/perl-$PERL_VERSION"
236 283
237 verblock <<EOF 284 verblock <<EOF
238building $STATICPERL/src/perl-$PERLVER 285building $STATICPERL/src/perl-$PERL_VERSION
239EOF 286EOF
240 287
241 rm -f "$PREFIX/staticstamp.install" 288 rm -f "$PERL_PREFIX/staticstamp.install"
242 289
243 make || fatal "make: error while building perl" 290 "$MAKE" || fatal "make: error while building perl"
244 291
245 postbuild || fatal "postbuild hook failed" 292 postbuild || fatal "postbuild hook failed"
246} 293}
247 294
248install() { 295install() {
249 [ -e "$PREFIX/staticstamp.install" ] && return 296 if ! [ -e "$PERL_PREFIX/staticstamp.install" ]; then
250
251 build 297 build
252 298
253 verblock <<EOF 299 verblock <<EOF
254installing $STATICPERL/src/perl-$PERLVER 300installing $STATICPERL/src/perl-$PERL_VERSION
255to $PREFIX 301to $PERL_PREFIX
256EOF 302EOF
257 303
258 rm -rf "$PREFIX" 304 ln -sf "perl/bin/" "$STATICPERL/bin"
259 305 ln -sf "perl/lib/" "$STATICPERL/lib"
306
307 ln -sf "$PERL_PREFIX" "$STATICPERL/perl" # might get overwritten
308 rm -rf "$PERL_PREFIX" # by this rm -rf
309
260 make install || fatal "make install: error while installing" 310 "$MAKE" install || fatal "make install: error while installing"
261 311
262 rcd "$PREFIX" 312 rcd "$PERL_PREFIX"
263 313
264 # create a "make install" replacement for CPAN 314 # create a "make install" replacement for CPAN
265 cat >"$PREFIX"/bin/cpan-make-install <<EOF 315 cat >"$PERL_PREFIX"/bin/cpan-make-install <<EOF
266make install UNINST=1 316"$MAKE" || exit
317
267if find blib/arch/auto -type f | grep -q -v .exists; then 318if find blib/arch/auto -type f | grep -q -v .exists; then
268 echo Probably an XS module, rebuilding perl 319 echo Probably an XS module, rebuilding perl
269 make perl 320 if "$MAKE" perl; then
321 mv perl "$PERL_PREFIX"/bin/perl~ \
270 rm -f "$PREFIX"/bin/perl 322 && rm -f "$PERL_PREFIX"/bin/perl \
271 make -f Makefile.aperl inst_perl 323 && mv "$PERL_PREFIX"/bin/perl~ "$PERL_PREFIX"/bin/perl
272 make -f Makefile.aperl map_clean 324 "$MAKE" -f Makefile.aperl map_clean
325 else
326 "$MAKE" -f Makefile.aperl map_clean
327 exit 1
328 fi
273fi 329fi
330
331"$MAKE" install UNINST=1
274EOF 332EOF
275 chmod 755 "$PREFIX"/bin/cpan-make-install 333 chmod 755 "$PERL_PREFIX"/bin/cpan-make-install
276 334
277 # trick CPAN into avoiding ~/.cpan completely 335 # trick CPAN into avoiding ~/.cpan completely
278 echo 1 >"$PREFIX/lib/CPAN/MyConfig.pm" 336 echo 1 >"$PERL_PREFIX/lib/CPAN/MyConfig.pm"
279 337
280 "$PREFIX"/bin/perl -MCPAN -e ' 338 "$PERL_PREFIX"/bin/perl -MCPAN -e '
281 CPAN::Shell->o (conf => urllist => push => "'"$CPAN"'"); 339 CPAN::Shell->o (conf => urllist => push => "'"$CPAN"'");
282 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan"); 340 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan");
283 CPAN::Shell->o (conf => q<init>); 341 CPAN::Shell->o (conf => q<init>);
284 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan"); 342 CPAN::Shell->o (conf => q<cpan_home>, "'"$STATICPERL"'/cpan");
285 CPAN::Shell->o (conf => q<build_dir>, "'"$STATICPERL"'/cpan/build"); 343 CPAN::Shell->o (conf => q<build_dir>, "'"$STATICPERL"'/cpan/build");
286 CPAN::Shell->o (conf => q<prefs_dir>, "'"$STATICPERL"'/cpan/prefs"); 344 CPAN::Shell->o (conf => q<prefs_dir>, "'"$STATICPERL"'/cpan/prefs");
287 CPAN::Shell->o (conf => q<histfile> , "'"$STATICPERL"'/cpan/histfile"); 345 CPAN::Shell->o (conf => q<histfile> , "'"$STATICPERL"'/cpan/histfile");
288 CPAN::Shell->o (conf => q<keep_source_where>, "'"$STATICPERL"'/cpan/sources"); 346 CPAN::Shell->o (conf => q<keep_source_where>, "'"$STATICPERL"'/cpan/sources");
289 CPAN::Shell->o (conf => q<make_install_make_command>, "'"$PREFIX"'/bin/cpan-make-install"); 347 CPAN::Shell->o (conf => q<make_install_make_command>, "'"$PERL_PREFIX"'/bin/cpan-make-install");
290 CPAN::Shell->o (conf => q<prerequisites_policy>, q<follow>); 348 CPAN::Shell->o (conf => q<prerequisites_policy>, q<follow>);
291 CPAN::Shell->o (conf => q<build_requires_install_policy>, q<no>); 349 CPAN::Shell->o (conf => q<build_requires_install_policy>, q<no>);
292 CPAN::Shell->o (conf => q<commit>); 350 CPAN::Shell->o (conf => q<commit>);
293 ' || fatal "error while initialising CPAN" 351 ' || fatal "error while initialising CPAN"
294 352
353 touch "$PERL_PREFIX/staticstamp.install"
354 fi
355
356 if ! [ -e "$PERL_PREFIX/staticstamp.postinstall" ]; then
295 NOCHECK_INSTALL=+ 357 NOCHECK_INSTALL=+
296 instcpan $STATICPERL_MODULES 358 instcpan $STATICPERL_MODULES
297 [ $EXTRA_MODULES ] && instcpan $EXTRA_MODULES 359 [ $EXTRA_MODULES ] && instcpan $EXTRA_MODULES
298 360
299 postinstall || fatal "postinstall hook failed" 361 postinstall || fatal "postinstall hook failed"
300 362
301 touch "$PREFIX/staticstamp.install" 363 touch "$PERL_PREFIX/staticstamp.postinstall"
364 fi
302} 365}
303 366
304############################################################################# 367#############################################################################
305# install a module from CPAN 368# install a module from CPAN
306 369
311installing modules from CPAN 374installing modules from CPAN
312$@ 375$@
313EOF 376EOF
314 377
315 for mod in "$@"; do 378 for mod in "$@"; do
316 "$PREFIX"/bin/perl -MCPAN -e 'notest install => "'"$mod"'"' \ 379 "$PERL_PREFIX"/bin/perl -MCPAN -e 'notest install => "'"$mod"'"' \
317 || fatal "$mod: unable to install from CPAN" 380 || fatal "$mod: unable to install from CPAN"
318 done 381 done
319 rm -rf "$STATICPERL/build" 382 rm -rf "$STATICPERL/build"
320} 383}
321 384
333 for mod in "$@"; do 396 for mod in "$@"; do
334 echo 397 echo
335 echo $mod 398 echo $mod
336 ( 399 (
337 rcd $mod 400 rcd $mod
338 make -f Makefile.aperl map_clean >/dev/null 2>&1 401 "$MAKE" -f Makefile.aperl map_clean >/dev/null 2>&1
339 make distclean >/dev/null 2>&1 402 "$MAKE" distclean >/dev/null 2>&1
340 "$PREFIX"/bin/perl Makefile.PL || fatal "$mod: error running Makefile.PL" 403 "$PERL_PREFIX"/bin/perl Makefile.PL || fatal "$mod: error running Makefile.PL"
341 make || fatal "$mod: error building module" 404 "$MAKE" || fatal "$mod: error building module"
342 "$PREFIX"/bin/cpan-make-install || fatal "$mod: error installing module" 405 "$PERL_PREFIX"/bin/cpan-make-install || fatal "$mod: error installing module"
343 make distclean >/dev/null 2>&1 406 "$MAKE" distclean >/dev/null 2>&1
344 exit 0 407 exit 0
345 ) || exit $? 408 ) || exit $?
346 done 409 done
347} 410}
348 411
349############################################################################# 412#############################################################################
350# do schmorpy stuff
351
352MODSRCDIR=~/src
353
354instmodsrc() {
355 for mod in "$@"; do
356 instmod_src "$MODSRCDIR/$mod"
357 done
358}
359
360install_schmorp() {
361 install
362
363 instcpan Data::Dump Term::ReadLine::Perl Term::ANSIColor Term::ReadKey
364 instcpan Digest::SHA Digest::MD6 Digest::SHA256 Digest::MD4 Digest::HMAC_MD5 Digest::HMAC_MD6 Digest::FNV
365 #instcpan Net::SSLeay # requires static -ldl
366
367 instmodsrc common-sense Crypt-Twofish2 Array-Heap Convert-Scalar Compress-LZF JSON-XS
368 instmodsrc EV Guard Async-Interrupt IO-AIO
369 instmodsrc AnyEvent AnyEvent-AIO Coro AnyEvent-HTTP
370 instmodsrc Linux-Inotify2 EV-Loop-Async
371
372 instcpan AnyEvent::HTTPD
373}
374
375#############################################################################
376# main 413# main
377 414
378podusage() { 415podusage() {
379 echo 416 echo
417
380 if [ -e "$PREFIX/bin/perl" ]; then 418 if [ -e "$PERL_PREFIX/bin/perl" ]; then
381 "$PREFIX/bin/perl" -MPod::Usage -e \ 419 "$PERL_PREFIX/bin/perl" -MPod::Usage -e \
382 'pod2usage -input => *STDIN, -output => *STDOUT, -verbose => '$1', -exitval => 0, -noperldoc => 1' <"$0" \ 420 'pod2usage -input => *STDIN, -output => *STDOUT, -verbose => '$1', -exitval => 0, -noperldoc => 1' <"$0" \
383 2>/dev/null && exit 421 2>/dev/null && exit
384 fi 422 fi
423
385 # try whatever perl we can find 424 # try whatever perl we can find
386 perl -MPod::Usage -e \ 425 perl -MPod::Usage -e \
387 'pod2usage -input => *STDIN, -output => *STDOUT, -verbose => '$1', -exitval => 0, -noperldoc => 1' <"$0" \ 426 'pod2usage -input => *STDIN, -output => *STDOUT, -verbose => '$1', -exitval => 0, -noperldoc => 1' <"$0" \
388 2>/dev/null && exit 427 2>/dev/null && exit
389 428
390 fatal "displaying documentation requires a working perl - try '$0 install' first" 429 fatal "displaying documentation requires a working perl - try '$0 install' to build one in a safe location"
391} 430}
392 431
393usage() { 432usage() {
394 podusage 0 433 podusage 0
395} 434}
396 435
397catmkbundle() { 436catmkbundle() {
398 { 437 {
399 read dummy 438 read dummy
400 echo "#!$PREFIX/bin/perl" 439 echo "#!$PERL_PREFIX/bin/perl"
401 cat 440 cat
402 } <<'MKBUNDLE' 441 } <<'MKBUNDLE'
403#CAT mkbundle 442#CAT mkbundle
404MKBUNDLE 443MKBUNDLE
405} 444}
406 445
407bundle() { 446bundle() {
408 catmkbundle >"$MKBUNDLE~" || fatal "$MKBUNDLE~: cannot create" 447 catmkbundle >"$MKBUNDLE~" || fatal "$MKBUNDLE~: cannot create"
409 chmod 755 "$MKBUNDLE~" && mv "$MKBUNDLE~" "$MKBUNDLE" 448 chmod 755 "$MKBUNDLE~" && mv "$MKBUNDLE~" "$MKBUNDLE"
449 CACHE="$STATICPERL/cache"
450 mkdir -p "$CACHE"
410 "$PREFIX/bin/perl" -- "$MKBUNDLE" "$@" 451 "$PERL_PREFIX/bin/perl" -- "$MKBUNDLE" --cache "$CACHE" "$@"
411} 452}
412 453
413if [ $# -gt 0 ]; then 454if [ $# -gt 0 ]; then
414 while [ $# -gt 0 ]; do 455 while [ $# -gt 0 ]; do
415 mkdir -p "$STATICPERL" || fatal "$STATICPERL: cannot create" 456 mkdir -p "$STATICPERL" || fatal "$STATICPERL: cannot create"
416 mkdir -p "$PREFIX" || fatal "$PREFIX: cannot create" 457 mkdir -p "$PERL_PREFIX" || fatal "$PERL_PREFIX: cannot create"
417 458
418 command="${1#--}"; shift 459 command="${1#--}"; shift
419 case "$command" in 460 case "$command" in
461 version )
462 echo "staticperl version $VERSION"
463 ;;
420 fetch | configure | build | install | clean | distclean) 464 fetch | configure | build | install | clean | realclean | distclean)
421 verblock <<EOF
422$command
423EOF
424 "$command" 465 ( "$command" ) || exit
425 ;; 466 ;;
426 instsrc ) 467 instsrc )
427 instsrc "$@" 468 ( instsrc "$@" ) || exit
428 exit 469 exit
429 ;; 470 ;;
430 instcpan ) 471 instcpan )
431 instcpan "$@" 472 ( instcpan "$@" ) || exit
432 exit 473 exit
433 ;; 474 ;;
434 instschmorp )
435 install_schmorp
436 ;;
437 cpan ) 475 cpan )
438 install 476 ( install ) || exit
439 "$PREFIX/bin/cpan" "$@" 477 "$PERL_PREFIX/bin/cpan" "$@"
440 exit 478 exit
441 ;; 479 ;;
442 mkbundle ) 480 mkbundle )
443 install 481 ( install ) || exit
444 bundle "$@" 482 bundle "$@"
445 exit 483 exit
446 ;; 484 ;;
447 mkperl ) 485 mkperl )
448 install 486 ( install ) || exit
449 bundle --perl "$@" 487 bundle --perl "$@"
488 exit
489 ;;
490 mkapp )
491 ( install ) || exit
492 bundle --app "$@"
450 exit 493 exit
451 ;; 494 ;;
452 help ) 495 help )
453 podusage 2 496 podusage 2
454 ;; 497 ;;

Diff Legend

Removed lines
+ Added lines
< Changed lines
> Changed lines